Package owl.automaton.acceptance.optimizations

## Class GeneralizedRabinAcceptanceOptimizations

- java.lang.Object
- - owl.automaton.acceptance.optimizations.GeneralizedRabinAcceptanceOptimizations

-     public final class GeneralizedRabinAcceptanceOptimizations
      extends Object

- - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static <S> void` | `mergeBuchiTypePairs​(MutableAutomaton<S,​GeneralizedRabinAcceptance> automaton)` |
    `static <S> void` | `minimizeEdgeImplications​(MutableAutomaton<S,​GeneralizedRabinAcceptance> automaton)` | Remove all Inf edges which are implied by another Inf index of the same pair.
    `static <S> void` | `minimizeMergePairs​(MutableAutomaton<S,​GeneralizedRabinAcceptance> automaton)` | Merge independent pairs.
    `static <S> void` | `minimizeOverlap​(MutableAutomaton<S,​GeneralizedRabinAcceptance> automaton)` | Remove edges in a Fin set from all corresponding Inf sets.
    `static <S> void` | `minimizePairImplications​(MutableAutomaton<S,​GeneralizedRabinAcceptance> automaton)` | Delete all pairs which only accept if another pair accepts.
    `static <S> void` | `minimizeSccIrrelevant​(MutableAutomaton<S,​GeneralizedRabinAcceptance> automaton)` | - Remove all indices from edges of an SCC which can't accept (e.g.
    `static <S> void` | `removeComplementaryInfSets​(MutableAutomaton<S,​GeneralizedRabinAcceptance> automaton)` | Delete all Inf sets which are the complement of their corresponding Fin set.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### removeComplementaryInfSets

          public static <S> void removeComplementaryInfSets​(MutableAutomaton<S,​GeneralizedRabinAcceptance> automaton)

      Delete all Inf sets which are the complement of their corresponding Fin set.

    - #### minimizeEdgeImplications

          public static <S> void minimizeEdgeImplications​(MutableAutomaton<S,​GeneralizedRabinAcceptance> automaton)

      Remove all Inf edges which are implied by another Inf index of the same pair.

    - #### minimizeMergePairs

          public static <S> void minimizeMergePairs​(MutableAutomaton<S,​GeneralizedRabinAcceptance> automaton)

      Merge independent pairs.

    - #### minimizeOverlap

          public static <S> void minimizeOverlap​(MutableAutomaton<S,​GeneralizedRabinAcceptance> automaton)

      Remove edges in a Fin set from all corresponding Inf sets.

    - #### minimizePairImplications

          public static <S> void minimizePairImplications​(MutableAutomaton<S,​GeneralizedRabinAcceptance> automaton)

      Delete all pairs which only accept if another pair accepts.

    - #### minimizeSccIrrelevant

          public static <S> void minimizeSccIrrelevant​(MutableAutomaton<S,​GeneralizedRabinAcceptance> automaton)

      - Remove all indices from edges of an SCC which can't accept (e.g. if the SCC does not contain all Inf sets of the pair). - Identify Fin-only pairs and SCCs which trivially accept with them. - Remove pairs which cannot accept globally (e.g. an Inf set does not occur)

    - #### mergeBuchiTypePairs

          public static <S> void mergeBuchiTypePairs​(MutableAutomaton<S,​GeneralizedRabinAcceptance> automaton)